package com.jasamedika.medifirst2000.controller;

import java.util.Collection;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.jasamedika.medifirst2000.constants.Constants;
import com.jasamedika.medifirst2000.constants.MessageResource;
import com.jasamedika.medifirst2000.controller.base.IBaseRestController;
import com.jasamedika.medifirst2000.controller.base.LocaleController;
import com.jasamedika.medifirst2000.core.web.WebConstants;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.FisisPemeriksaanDokterService;
import com.jasamedika.medifirst2000.util.DateUtil;
import com.jasamedika.medifirst2000.util.rest.RestUtil;
import com.jasamedika.medifirst2000.vo.FisisPemeriksaanDokterVO;

/**
 * Controller class for FisisPemeriksaanDokterController
 * 
 * @author Askur
 */
@RestController
@RequestMapping("/fisis-dokter")
@JsonIgnoreProperties(ignoreUnknown = true) 
public class FisisPemeriksaanDokterController extends LocaleController<FisisPemeriksaanDokterVO> implements
		IBaseRestController<FisisPemeriksaanDokterVO> {
	
	private static final Logger LOGGER = LoggerFactory.getLogger(FisisPemeriksaanDokterController.class);

	@Autowired
	private FisisPemeriksaanDokterService fisisPemeriksaanDokterService;

	@RequestMapping(value = "/save-fisis-dokter", method = RequestMethod.POST, produces = MediaType.APPLICATION_JSON_VALUE, consumes = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> save(@Valid @RequestBody FisisPemeriksaanDokterVO vo,HttpServletRequest request) {
		try {
			Map<String,Object> result = fisisPemeriksaanDokterService.addFisisPemeriksaanDokter(vo);
			if (null != result){
				mapHeaderMessage.clear();
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
			}else{
				mapHeaderMessage.clear();
				mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
			}
			SaveLog("Pemeriksaan Fisis Dokter", "Dokter",request);
			return RestUtil.getJsonResponse(result, HttpStatus.CREATED,mapHeaderMessage);

		} catch (ServiceVOException e) {
			LOGGER.error("Got exception {} when add pemeriksaan fisis", e.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, e.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.INTERNAL_SERVER_ERROR, mapHeaderMessage);
		} catch (JpaSystemException jse) {
			LOGGER.error("Got exception {} when add pemeriksaan fisis", jse.getMessage());
			addHeaderMessage(Constants.MessageInfo.ERROR_MESSAGE, jse.getMessage());
			return RestUtil.getJsonHttptatus(HttpStatus.CONFLICT, mapHeaderMessage);
		}

	}

	@RequestMapping(value = "/find-fisis-dokter", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<Map<String,Object>> findByNoRec(@RequestParam("noRec") String noRec,HttpServletRequest request) {
		Map<String,Object> result = fisisPemeriksaanDokterService.findFisisPemeriksaanDokterByNoRec(noRec);
		Boolean dataFound=new Boolean((boolean) result.get("dataFound"));
		if(dataFound){
			mapHeaderMessage.clear();
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_SUCCESS,getMessage(MessageResource.LABEL_SUCCESS,request ));
		}else{
			mapHeaderMessage.clear();
			mapHeaderMessage.put(WebConstants.HttpHeaderInfo.LABEL_ERROR,getMessage(MessageResource.LABEL_ERROR,request ));
		}

		return RestUtil.getJsonResponse(result, HttpStatus.OK,mapHeaderMessage);
	}
	
	@Override
	public ResponseEntity<Collection<FisisPemeriksaanDokterVO>> getAllVOWithQueryString(HttpServletRequest request,
			Integer page, Integer limit, String sort, String dir) {
		return null;
	}

	@Override
	public ResponseEntity<FisisPemeriksaanDokterVO> getVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<String> addVO(FisisPemeriksaanDokterVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> editVO(FisisPemeriksaanDokterVO vo) {
		return null;
	}

	@Override
	public ResponseEntity<String> deleteVO(Integer id) {
		return null;
	}

	@Override
	public ResponseEntity<List<FisisPemeriksaanDokterVO>> getAllVO() {
		return null;
	}



	
}
